diff --git a/ldap/servers/slapd/back-ldbm/ldbm_config.c b/ldap/servers/slapd/back-ldbm/ldbm_config.c
index 67a647540..88bd32a2f 100644
--- a/ldap/servers/slapd/back-ldbm/ldbm_config.c
+++ b/ldap/servers/slapd/back-ldbm/ldbm_config.c
@@ -480,960 +501,264 @@ ldbm_config_dbcachesize_set(void *arg, void *value, char *errorbuf, int phase, i
                 slapi_log_err(SLAPI_LOG_NOTICE, "ldbm_config_dbcachesize_set", "New db cache size will not take affect until the server is restarted\n");
             }
         } else {
-            li->li_new_dbcachesize = val;
-            li->li_dbcachesize = val;
-        }
-    }
-
-    return retval;
-}
-
-static void *
-ldbm_config_maxpassbeforemerge_get(void *arg)
-{
-    struct ldbminfo *li = (struct ldbminfo *)arg;
-
-    return (void *)((uintptr_t)(li->li_maxpassbeforemerge));
-}
-
-static int
-ldbm_config_maxpassbeforemerge_set(void *arg, void *value, char *errorbuf __attribute__((unused)), int phase __attribute__((unused)), int apply)
-{
-    struct ldbminfo *li = (struct ldbminfo *)arg;
-    int retval = LDAP_SUCCESS;
-    int val = (int)((uintptr_t)value);
-
-    if (apply) {
-        if (val < 0) {
-            slapi_log_err(SLAPI_LOG_NOTICE, "ldbm_config_maxpassbeforemerge_set",
-                          "maxpassbeforemerge will not take negative value - setting to 100\n");
-            val = 100;
-        }
-
-        li->li_maxpassbeforemerge = val;
-    }
-
-    return retval;
-}
-
-
-static void *
-ldbm_config_dbncache_get(void *arg)
-{
-    struct ldbminfo *li = (struct ldbminfo *)arg;
-
-    return (void *)((uintptr_t)(li->li_new_dbncache));
-}
-
-static int
-ldbm_config_dbncache_set(void *arg, void *value, char *errorbuf __attribute__((unused)), int phase, int apply)
-{
-    struct ldbminfo *li = (struct ldbminfo *)arg;
-    int retval = LDAP_SUCCESS;
-    size_t val = (size_t)((uintptr_t)value);
-
-    if (apply) {
-
-        if (CONFIG_PHASE_RUNNING == phase) {
-            li->li_new_dbncache = val;
-            slapi_log_err(SLAPI_LOG_NOTICE, "ldbm_config_dbncache_set",
-                          "New nsslapd-dbncache will not take affect until the server is restarted\n");
-        } else {
-            li->li_new_dbncache = val;
-            li->li_dbncache = val;
-        }
-    }
-
-    return retval;
-}
-
-void *
-ldbm_config_db_logdirectory_get(void *arg)
-{
-    struct ldbminfo *li = (struct ldbminfo *)arg;
-
-    /* Remember get functions of type string need to return
-     * alloced memory. */
-    /* if dblayer_log_directory is set to a string different from ""
-     * then it has been set, return this variable
-     * otherwise it is set to default, use the instance home directory
-     */
-    if (strlen(li->li_dblayer_private->dblayer_log_directory) > 0)
-        return (void *)slapi_ch_strdup(li->li_dblayer_private->dblayer_log_directory);
-    else
-        return (void *)slapi_ch_strdup(li->li_new_directory);
-}
-
-/* Does not return a copy of the string - used by disk space monitoring feature */
-void *
-ldbm_config_db_logdirectory_get_ext(void *arg)
-{
-    struct ldbminfo *li = (struct ldbminfo *)arg;
-
-    if (strlen(li->li_dblayer_private->dblayer_log_directory) > 0)
-        return (void *)li->li_dblayer_private->dblayer_log_directory;
-    else
-        return (void *)li->li_new_directory;
-}
-
-static int
-ldbm_config_db_logdirectory_set(void *arg, void *value, char *errorbuf __attribute__((unused)), int phase __attribute__((unused)), int apply)
-{
-    struct ldbminfo *li = (struct ldbminfo *)arg;
-    int retval = LDAP_SUCCESS;
-    char *val = (char *)value;
-
-    if (apply) {
-        slapi_ch_free((void **)&(li->li_dblayer_private->dblayer_log_directory));
-        li->li_dblayer_private->dblayer_log_directory = slapi_ch_strdup(val);
-    }
-
-    return retval;
-}
-
-static void *
-ldbm_config_db_durable_transactions_get(void *arg)
-{
-    struct ldbminfo *li = (struct ldbminfo *)arg;
-
-    return (void *)((uintptr_t)li->li_dblayer_private->dblayer_durable_transactions);
-}
-
-static int
-ldbm_config_db_durable_transactions_set(void *arg, void *value, char *errorbuf __attribute__((unused)), int phase __attribute__((unused)), int apply)
-{
-    struct ldbminfo *li = (struct ldbminfo *)arg;
-    int retval = LDAP_SUCCESS;
-    int val = (int)((uintptr_t)value);
-
-    if (apply) {
-        li->li_dblayer_private->dblayer_durable_transactions = val;
-    }
-
-    return retval;
-}
-
-static void *
-ldbm_config_db_lockdown_get(void *arg)
-{
-    struct ldbminfo *li = (struct ldbminfo *)arg;
-
-    return (void *)((uintptr_t)li->li_dblayer_private->dblayer_lockdown);
-}
-
-static int
-ldbm_config_db_lockdown_set(
-    void *arg,
-    void *value,
-    char *errorbuf __attribute__((unused)),
-    int phase __attribute__((unused)),
-    int apply)
-{
-    struct ldbminfo *li = (struct ldbminfo *)arg;
-    int retval = LDAP_SUCCESS;
-    int val = (int)((uintptr_t)value);
-
-    if (apply) {
-        li->li_dblayer_private->dblayer_lockdown = val;
-    }
-
-    return retval;
-}
-
-static void *
-ldbm_config_db_circular_logging_get(void *arg)
-{
-    struct ldbminfo *li = (struct ldbminfo *)arg;
-
-    return (void *)((uintptr_t)li->li_dblayer_private->dblayer_circular_logging);
-}
-
-static int
-ldbm_config_db_circular_logging_set(void *arg,
-                                    void *value,
-                                    char *errorbuf __attribute__((unused)),
-                                    int phase __attribute__((unused)),
-                                    int apply)
-{
-    struct ldbminfo *li = (struct ldbminfo *)arg;
-    int retval = LDAP_SUCCESS;
-    int val = (int)((uintptr_t)value);
-
-    if (apply) {
-        li->li_dblayer_private->dblayer_circular_logging = val;
-    }
-
-    return retval;
-}
-
-static void *
-ldbm_config_db_transaction_logging_get(void *arg)
-{
-    struct ldbminfo *li = (struct ldbminfo *)arg;
-
-    return (void *)((uintptr_t)li->li_dblayer_private->dblayer_enable_transactions);
-}
-
-static int
-ldbm_config_db_transaction_logging_set(void *arg,
-                                       void *value,
-                                       char *errorbuf __attribute__((unused)),
-                                       int phase __attribute__((unused)),
-                                       int apply)
-{
-    struct ldbminfo *li = (struct ldbminfo *)arg;
-    int retval = LDAP_SUCCESS;
-    int val = (int)((uintptr_t)value);
-
-    if (apply) {
-        li->li_dblayer_private->dblayer_enable_transactions = val;
-    }
-
-    return retval;
-}
-
-
-static void *
-ldbm_config_db_transaction_wait_get(void *arg)
-{
-    struct ldbminfo *li = (struct ldbminfo *)arg;
-
-    return (void *)((uintptr_t)li->li_dblayer_private->dblayer_txn_wait);
-}
-
-static int
-ldbm_config_db_transaction_wait_set(void *arg,
-                                    void *value,
-                                    char *errorbuf __attribute__((unused)),
-                                    int phase __attribute__((unused)),
-                                    int apply)
-{
-    struct ldbminfo *li = (struct ldbminfo *)arg;
-    int retval = LDAP_SUCCESS;
-    int val = (int)((uintptr_t)value);
-
-    if (apply) {
-        li->li_dblayer_private->dblayer_txn_wait = val;
-    }
-
-    return retval;
-}
-
-static void *
-ldbm_config_db_logbuf_size_get(void *arg)
-{
-    struct ldbminfo *li = (struct ldbminfo *)arg;
-
-    return (void *)((uintptr_t)li->li_dblayer_private->dblayer_logbuf_size);
-}
-
-static int
-ldbm_config_db_logbuf_size_set(void *arg,
-                               void *value,
-                               char *errorbuf __attribute__((unused)),
-                               int phase __attribute__((unused)),
-                               int apply)
-{
-    struct ldbminfo *li = (struct ldbminfo *)arg;
-    int retval = LDAP_SUCCESS;
-    uint64_t val = (uint64_t)((uintptr_t)value);
-
-    if (apply) {
-        li->li_dblayer_private->dblayer_logbuf_size = val;
-    }
-
-    return retval;
-}
-
-static void *
-ldbm_config_db_checkpoint_interval_get(void *arg)
-{
-    struct ldbminfo *li = (struct ldbminfo *)arg;
-
-    return (void *)((uintptr_t)li->li_dblayer_private->dblayer_checkpoint_interval);
-}
-
-static int
-ldbm_config_db_checkpoint_interval_set(void *arg,
-                                       void *value,
-                                       char *errorbuf __attribute__((unused)),
-                                       int phase __attribute__((unused)),
-                                       int apply)
-{
-    struct ldbminfo *li = (struct ldbminfo *)arg;
-    int retval = LDAP_SUCCESS;
-    int val = (int)((uintptr_t)value);
-
-    if (apply) {
-        li->li_dblayer_private->dblayer_checkpoint_interval = val;
-    }
-
-    return retval;
-}
-
-static void *
-ldbm_config_db_compactdb_interval_get(void *arg)
-{
-    struct ldbminfo *li = (struct ldbminfo *)arg;
-
-    return (void *)((uintptr_t)li->li_dblayer_private->dblayer_compactdb_interval);
-}
-
-static int
-ldbm_config_db_compactdb_interval_set(void *arg,
-                                      void *value,
-                                      char *errorbuf __attribute__((unused)),
-                                      int phase __attribute__((unused)),
-                                      int apply)
-{
-    struct ldbminfo *li = (struct ldbminfo *)arg;
-    int retval = LDAP_SUCCESS;
-    int val = (int)((uintptr_t)value);
-
-    if (apply) {
-        li->li_dblayer_private->dblayer_compactdb_interval = val;
-    }
-
-    return retval;
-}
-
-static void *
-ldbm_config_db_page_size_get(void *arg)
-{
-    struct ldbminfo *li = (struct ldbminfo *)arg;
-
-    return (void *)((uintptr_t)li->li_dblayer_private->dblayer_page_size);
-}
-
-static int
-ldbm_config_db_page_size_set(void *arg,
-                             void *value,
-                             char *errorbuf __attribute__((unused)),
-                             int phase __attribute__((unused)),
-                             int apply)
-{
-    struct ldbminfo *li = (struct ldbminfo *)arg;
-    int retval = LDAP_SUCCESS;
-    uint32_t val = (uint32_t)((uintptr_t)value);
-
-    if (apply) {
-        li->li_dblayer_private->dblayer_page_size = val;
-    }
-
-    return retval;
-}
-
-static void *
-ldbm_config_db_index_page_size_get(void *arg)
-{
-    struct ldbminfo *li = (struct ldbminfo *)arg;
-
-    return (void *)((uintptr_t)li->li_dblayer_private->dblayer_index_page_size);
-}
-
-static int
-ldbm_config_db_index_page_size_set(void *arg,
-                                   void *value,
-                                   char *errorbuf __attribute__((unused)),
-                                   int phase __attribute__((unused)),
-                                   int apply)
-{
-    struct ldbminfo *li = (struct ldbminfo *)arg;
-    int retval = LDAP_SUCCESS;
-    uint32_t val = (uint32_t)((uintptr_t)value);
-
-    if (apply) {
-        li->li_dblayer_private->dblayer_index_page_size = val;
-    }
-
-    return retval;
-}
-
-static void *
-ldbm_config_db_idl_divisor_get(void *arg)
-{
-    struct ldbminfo *li = (struct ldbminfo *)arg;
-
-    return (void *)((uintptr_t)li->li_dblayer_private->dblayer_idl_divisor);
-}
-
-static int
-ldbm_config_db_idl_divisor_set(void *arg,
-                               void *value,
-                               char *errorbuf __attribute__((unused)),
-                               int phase __attribute__((unused)),
-                               int apply)
-{
-    struct ldbminfo *li = (struct ldbminfo *)arg;
-    int retval = LDAP_SUCCESS;
-    int val = (int)((uintptr_t)value);
-
-    if (apply) {
-        li->li_dblayer_private->dblayer_idl_divisor = val;
-    }
-
-    return retval;
-}
-
-static void *
-ldbm_config_db_old_idl_maxids_get(void *arg)
-{
-    struct ldbminfo *li = (struct ldbminfo *)arg;
-
-    return (void *)((uintptr_t)li->li_old_idl_maxids);
-}
-
-static int
-ldbm_config_db_old_idl_maxids_set(void *arg,
-                                  void *value,
-                                  char *errorbuf,
-                                  int phase __attribute__((unused)),
-                                  int apply)
-{
-    struct ldbminfo *li = (struct ldbminfo *)arg;
-    int retval = LDAP_SUCCESS;
-    int val = (int)((uintptr_t)value);
-
-    if (apply) {
-        if (val >= 0) {
-            li->li_old_idl_maxids = val;
-        } else {
-            slapi_create_errormsg(errorbuf, SLAPI_DSE_RETURNTEXT_SIZE,
-                                  "Error: Invalid value for %s (%d). Value must be equal or greater than zero.",
-                                  CONFIG_DB_OLD_IDL_MAXIDS, val);
-            return LDAP_UNWILLING_TO_PERFORM;
-        }
-    }
-
-    return retval;
-}
-
-static void *
-ldbm_config_db_logfile_size_get(void *arg)
-{
-    struct ldbminfo *li = (struct ldbminfo *)arg;
-
-    return (void *)((uintptr_t)li->li_dblayer_private->dblayer_logfile_size);
-}
-
-static int
-ldbm_config_db_logfile_size_set(void *arg,
-                                void *value,
-                                char *errorbuf __attribute__((unused)),
-                                int phase __attribute__((unused)),
-                                int apply)
-{
-    struct ldbminfo *li = (struct ldbminfo *)arg;
-    int retval = LDAP_SUCCESS;
-    uint64_t val = (uint64_t)((uintptr_t)value);
-
-    if (apply) {
-        li->li_dblayer_private->dblayer_logfile_size = val;
-    }
-
-    return retval;
-}
-
-static void *
-ldbm_config_db_spin_count_get(void *arg)
-{
-    struct ldbminfo *li = (struct ldbminfo *)arg;
-
-    return (void *)((uintptr_t)li->li_dblayer_private->dblayer_spin_count);
-}
-
-static int
-ldbm_config_db_spin_count_set(void *arg,
-                              void *value,
-                              char *errorbuf __attribute__((unused)),
-                              int phase __attribute__((unused)),
-                              int apply)
-{
-    struct ldbminfo *li = (struct ldbminfo *)arg;
-    int retval = LDAP_SUCCESS;
-    int val = (int)((uintptr_t)value);
-
-    if (apply) {
-        li->li_dblayer_private->dblayer_spin_count = val;
-    }
-
-    return retval;
-}
-
-static void *
-ldbm_config_db_trickle_percentage_get(void *arg)
-{
-    struct ldbminfo *li = (struct ldbminfo *)arg;
-
-    return (void *)((uintptr_t)li->li_dblayer_private->dblayer_trickle_percentage);
-}
-
-static int
-ldbm_config_db_trickle_percentage_set(void *arg,
-                                      void *value,
-                                      char *errorbuf,
-                                      int phase __attribute__((unused)),
-                                      int apply)
-{
-    struct ldbminfo *li = (struct ldbminfo *)arg;
-    int retval = LDAP_SUCCESS;
-    int val = (int)((uintptr_t)value);
-
-    if (val < 0 || val > 100) {
-        slapi_create_errormsg(errorbuf, SLAPI_DSE_RETURNTEXT_SIZE, "Error: Invalid value for %s (%d). Must be between 0 and 100\n",
-                              CONFIG_DB_TRICKLE_PERCENTAGE, val);
-        slapi_log_err(SLAPI_LOG_ERR, "ldbm_config_db_trickle_percentage_set",
-                      "Invalid value for %s (%d). Must be between 0 and 100\n",
-                      CONFIG_DB_TRICKLE_PERCENTAGE, val);
-        return LDAP_UNWILLING_TO_PERFORM;
-    }
-
-    if (apply) {
-        li->li_dblayer_private->dblayer_trickle_percentage = val;
-    }
-
-    return retval;
-}
-
-static void *
-ldbm_config_db_verbose_get(void *arg)
-{
-    struct ldbminfo *li = (struct ldbminfo *)arg;
-
-    return (void *)((uintptr_t)li->li_dblayer_private->dblayer_verbose);
-}
-
-static int
-ldbm_config_db_verbose_set(void *arg,
-                           void *value,
-                           char *errorbuf __attribute__((unused)),
-                           int phase __attribute__((unused)),
-                           int apply)
-{
-    struct ldbminfo *li = (struct ldbminfo *)arg;
-    int retval = LDAP_SUCCESS;
-    int val = (int)((uintptr_t)value);
-
-    if (apply) {
-        li->li_dblayer_private->dblayer_verbose = val;
-    }
-
-    return retval;
-}
-
-static void *
-ldbm_config_db_debug_get(void *arg)
-{
-    struct ldbminfo *li = (struct ldbminfo *)arg;
-
-    return (void *)((uintptr_t)li->li_dblayer_private->dblayer_debug);
-}
-
-static int
-ldbm_config_db_debug_set(void *arg,
-                         void *value,
-                         char *errorbuf __attribute__((unused)),
-                         int phase __attribute__((unused)),
-                         int apply)
-{
-    struct ldbminfo *li = (struct ldbminfo *)arg;
-    int retval = LDAP_SUCCESS;
-    int val = (int)((uintptr_t)value);
-
-    if (apply) {
-        li->li_dblayer_private->dblayer_debug = val;
-    }
-
-    return retval;
-}
-
-static void *
-ldbm_config_db_named_regions_get(void *arg)
-{
-    struct ldbminfo *li = (struct ldbminfo *)arg;
-
-    return (void *)((uintptr_t)li->li_dblayer_private->dblayer_named_regions);
-}
-
-static int
-ldbm_config_db_named_regions_set(void *arg,
-                                 void *value,
-                                 char *errorbuf __attribute__((unused)),
-                                 int phase __attribute__((unused)),
-                                 int apply)
-{
-    struct ldbminfo *li = (struct ldbminfo *)arg;
-    int retval = LDAP_SUCCESS;
-    int val = (int)((uintptr_t)value);
-
-    if (apply) {
-        li->li_dblayer_private->dblayer_named_regions = val;
-    }
-
-    return retval;
-}
-
-static void *
-ldbm_config_db_private_mem_get(void *arg)
-{
-    struct ldbminfo *li = (struct ldbminfo *)arg;
-
-    return (void *)((uintptr_t)li->li_dblayer_private->dblayer_private_mem);
-}
-
-static int
-ldbm_config_db_private_mem_set(void *arg,
-                               void *value,
-                               char *errorbuf __attribute__((unused)),
-                               int phase __attribute__((unused)),
-                               int apply)
-{
-    struct ldbminfo *li = (struct ldbminfo *)arg;
-    int retval = LDAP_SUCCESS;
-    int val = (int)((uintptr_t)value);
-
-    if (apply) {
-        li->li_dblayer_private->dblayer_private_mem = val;
-    }
-
-    return retval;
-}
-
-static void *
-ldbm_config_db_online_import_encrypt_get(void *arg)
-{
-    struct ldbminfo *li = (struct ldbminfo *)arg;
-
-    return (void *)((uintptr_t)li->li_online_import_encrypt);
-}
-
-static int
-ldbm_config_db_online_import_encrypt_set(void *arg,
-                                         void *value,
-                                         char *errorbuf __attribute__((unused)),
-                                         int phase __attribute__((unused)),
-                                         int apply)
-{
-    struct ldbminfo *li = (struct ldbminfo *)arg;
-    int retval = LDAP_SUCCESS;
-    int val = (int)((uintptr_t)value);
-
-    if (apply) {
-        li->li_online_import_encrypt = val;
+            li->li_new_dbcachesize = val;
+            li->li_dbcachesize = val;
+        }
     }
 
     return retval;
 }
 
 static void *
-ldbm_config_db_private_import_mem_get(void *arg)
-{
-    struct ldbminfo *li = (struct ldbminfo *)arg;
-
-    return (void *)((uintptr_t)li->li_dblayer_private->dblayer_private_import_mem);
-}
-
-static void *
-ldbm_config_idl_get_update(void *arg)
+ldbm_config_maxpassbeforemerge_get(void *arg)
 {
     struct ldbminfo *li = (struct ldbminfo *)arg;
 
-    return (void *)((uintptr_t)li->li_idl_update);
+    return (void *)((uintptr_t)(li->li_maxpassbeforemerge));
 }
 
 static int
-ldbm_config_idl_set_update(void *arg,
-                           void *value,
-                           char *errorbuf __attribute__((unused)),
-                           int phase __attribute__((unused)),
-                           int apply)
+ldbm_config_maxpassbeforemerge_set(void *arg, void *value, char *errorbuf __attribute__((unused)), int phase __attribute__((unused)), int apply)
 {
     struct ldbminfo *li = (struct ldbminfo *)arg;
     int retval = LDAP_SUCCESS;
     int val = (int)((uintptr_t)value);
 
     if (apply) {
-        li->li_idl_update = val;
-    }
-
-    return retval;
-}
-
-static int
-ldbm_config_db_private_import_mem_set(void *arg,
-                                      void *value,
-                                      char *errorbuf __attribute__((unused)),
-                                      int phase __attribute__((unused)),
-                                      int apply)
-{
-    struct ldbminfo *li = (struct ldbminfo *)arg;
-    int retval = LDAP_SUCCESS;
-    int val = (int)((uintptr_t)value);
+        if (val < 0) {
+            slapi_log_err(SLAPI_LOG_NOTICE, "ldbm_config_maxpassbeforemerge_set",
+                          "maxpassbeforemerge will not take negative value - setting to 100\n");
+            val = 100;
+        }
 
-    if (apply) {
-        li->li_dblayer_private->dblayer_private_import_mem = val;
+        li->li_maxpassbeforemerge = val;
     }
 
     return retval;
 }
 
+
 static void *
-ldbm_config_db_shm_key_get(void *arg)
+ldbm_config_dbncache_get(void *arg)
 {
     struct ldbminfo *li = (struct ldbminfo *)arg;
 
-    return (void *)li->li_dblayer_private->dblayer_shm_key;
+    return (void *)((uintptr_t)(li->li_new_dbncache));
 }
 
 static int
-ldbm_config_db_shm_key_set(
-    void *arg,
-    void *value,
-    char *errorbuf __attribute__((unused)),
-    int phase __attribute__((unused)),
-    int apply)
+ldbm_config_dbncache_set(void *arg, void *value, char *errorbuf __attribute__((unused)), int phase, int apply)
 {
     struct ldbminfo *li = (struct ldbminfo *)arg;
     int retval = LDAP_SUCCESS;
-    int val = (int)((uintptr_t)value);
+    size_t val = (size_t)((uintptr_t)value);
 
     if (apply) {
-        li->li_dblayer_private->dblayer_shm_key = val;
+
+        if (CONFIG_PHASE_RUNNING == phase) {
+            li->li_new_dbncache = val;
+            slapi_log_err(SLAPI_LOG_NOTICE, "ldbm_config_dbncache_set",
+                          "New nsslapd-dbncache will not take affect until the server is restarted\n");
+        } else {
+            li->li_new_dbncache = val;
+            li->li_dbncache = val;
+        }
     }
 
     return retval;
 }
 
 static void *
-ldbm_config_db_lock_get(void *arg)
+ldbm_config_db_transaction_logging_get(void *arg)
 {
     struct ldbminfo *li = (struct ldbminfo *)arg;
 
-    return (void *)((uintptr_t)li->li_new_dblock);
+    return (void *)((uintptr_t)li->li_dblayer_private->dblayer_enable_transactions);
 }
 
-
 static int
-ldbm_config_db_lock_set(void *arg, void *value, char *errorbuf, int phase, int apply)
+ldbm_config_db_transaction_logging_set(void *arg,
+                                       void *value,
+                                       char *errorbuf __attribute__((unused)),
+                                       int phase __attribute__((unused)),
+                                       int apply)
 {
     struct ldbminfo *li = (struct ldbminfo *)arg;
     int retval = LDAP_SUCCESS;
-    uint64_t val = (uint64_t)((uintptr_t)value);
+    int val = (int)((uintptr_t)value);
 
-    if (val < BDB_LOCK_NB_MIN) {
-        slapi_create_errormsg(errorbuf, SLAPI_DSE_RETURNTEXT_SIZE, "Error: Invalid value for %s (%d). Must be greater than %d\n",
-                              CONFIG_DB_LOCK, val, BDB_LOCK_NB_MIN);
-        slapi_log_err(SLAPI_LOG_ERR, "ldbm_config_db_lock_set", "Invalid value for %s (%" PRIu64 ")\n",
-                      CONFIG_DB_LOCK, val);
-        return LDAP_UNWILLING_TO_PERFORM;
-    }
     if (apply) {
-        if (CONFIG_PHASE_RUNNING == phase) {
-            li->li_new_dblock = val;
-            slapi_log_err(SLAPI_LOG_NOTICE, "ldbm_config_db_lock_set",
-                          "New db max lock count will not take affect until the server is restarted\n");
-        } else {
-            li->li_new_dblock = val;
-            li->li_dblock = val;
-        }
+        li->li_dblayer_private->dblayer_enable_transactions = val;
     }
 
     return retval;
 }
+
+
 static void *
-ldbm_config_db_cache_get(void *arg)
+ldbm_config_db_idl_divisor_get(void *arg)
 {
     struct ldbminfo *li = (struct ldbminfo *)arg;
 
-    return (void *)((uintptr_t)li->li_dblayer_private->dblayer_cache_config);
+    return (void *)((uintptr_t)li->li_dblayer_private->dblayer_idl_divisor);
 }
 
 static int
-ldbm_config_db_cache_set(void *arg,
-                         void *value,
-                         char *errorbuf,
-                         int phase __attribute__((unused)),
-                         int apply)
+ldbm_config_db_idl_divisor_set(void *arg,
+                               void *value,
+                               char *errorbuf __attribute__((unused)),
+                               int phase __attribute__((unused)),
+                               int apply)
 {
     struct ldbminfo *li = (struct ldbminfo *)arg;
     int retval = LDAP_SUCCESS;
-    int val = ((uintptr_t)value);
-    uint64_t delta = 0;
-
-    /* There is an error here. We check the new val against our current mem-alloc
-     * Issue is that we already are using system pages, so while our value *might*
-     * be valid, we may reject it here due to the current procs page usage.
-     *
-     * So how do we solve this? If we are setting a SMALLER value than we
-     * currently have ALLOW it, because we already passed the cache sanity.
-     * If we are setting a LARGER value, we check the delta of the two, and make
-     * sure that it is sane.
-     */
+    int val = (int)((uintptr_t)value);
 
     if (apply) {
-        if (val > li->li_dblayer_private->dblayer_cache_config) {
-            delta = val - li->li_dblayer_private->dblayer_cache_config;
-            util_cachesize_result sane;
-
-            slapi_pal_meminfo *mi = spal_meminfo_get();
-            sane = util_is_cachesize_sane(mi, &delta);
-            spal_meminfo_destroy(mi);
-
-            if (sane != UTIL_CACHESIZE_VALID) {
-                slapi_create_errormsg(errorbuf, SLAPI_DSE_RETURNTEXT_SIZE, "Error: db cachesize value is too large");
-                slapi_log_err(SLAPI_LOG_ERR, "ldbm_config_db_cache_set", "db cachesize value is too large.\n");
-                return LDAP_UNWILLING_TO_PERFORM;
-            }
-        }
-        li->li_dblayer_private->dblayer_cache_config = val;
+        li->li_dblayer_private->dblayer_idl_divisor = val;
     }
 
     return retval;
 }
 
 static void *
-ldbm_config_db_debug_checkpointing_get(void *arg)
+ldbm_config_db_old_idl_maxids_get(void *arg)
 {
     struct ldbminfo *li = (struct ldbminfo *)arg;
 
-    return (void *)((uintptr_t)li->li_dblayer_private->db_debug_checkpointing);
+    return (void *)((uintptr_t)li->li_old_idl_maxids);
 }
 
 static int
-ldbm_config_db_debug_checkpointing_set(void *arg,
-                                       void *value,
-                                       char *errorbuf __attribute__((unused)),
-                                       int phase __attribute__((unused)),
-                                       int apply)
+ldbm_config_db_old_idl_maxids_set(void *arg,
+                                  void *value,
+                                  char *errorbuf,
+                                  int phase __attribute__((unused)),
+                                  int apply)
 {
     struct ldbminfo *li = (struct ldbminfo *)arg;
     int retval = LDAP_SUCCESS;
     int val = (int)((uintptr_t)value);
 
     if (apply) {
-        li->li_dblayer_private->db_debug_checkpointing = val;
+        if (val >= 0) {
+            li->li_old_idl_maxids = val;
+        } else {
+            slapi_create_errormsg(errorbuf, SLAPI_DSE_RETURNTEXT_SIZE,
+                                  "Error: Invalid value for %s (%d). Value must be equal or greater than zero.",
+                                  CONFIG_DB_OLD_IDL_MAXIDS, val);
+            return LDAP_UNWILLING_TO_PERFORM;
+        }
     }
 
     return retval;
 }
 
 static void *
-ldbm_config_db_home_directory_get(void *arg)
+ldbm_config_db_verbose_get(void *arg)
 {
     struct ldbminfo *li = (struct ldbminfo *)arg;
 
-    /* Remember get functions of type string need to return
-     * alloced memory. */
-    return (void *)slapi_ch_strdup(li->li_dblayer_private->dblayer_dbhome_directory);
+    return (void *)((uintptr_t)li->li_dblayer_private->dblayer_verbose);
 }
 
 static int
-ldbm_config_db_home_directory_set(void *arg,
-                                  void *value,
-                                  char *errorbuf __attribute__((unused)),
-                                  int phase __attribute__((unused)),
-                                  int apply)
+ldbm_config_db_verbose_set(void *arg,
+                           void *value,
+                           char *errorbuf __attribute__((unused)),
+                           int phase __attribute__((unused)),
+                           int apply)
 {
     struct ldbminfo *li = (struct ldbminfo *)arg;
     int retval = LDAP_SUCCESS;
-    char *val = (char *)value;
+    int val = (int)((uintptr_t)value);
 
     if (apply) {
-        slapi_ch_free((void **)&(li->li_dblayer_private->dblayer_dbhome_directory));
-        li->li_dblayer_private->dblayer_dbhome_directory = slapi_ch_strdup(val);
+        li->li_dblayer_private->dblayer_verbose = val;
     }
 
     return retval;
 }
 
 static void *
-ldbm_config_import_cache_autosize_get(void *arg)
+ldbm_config_db_debug_get(void *arg)
 {
     struct ldbminfo *li = (struct ldbminfo *)arg;
 
-    return (void *)((uintptr_t)(li->li_import_cache_autosize));
+    return (void *)((uintptr_t)li->li_dblayer_private->dblayer_debug);
 }
 
 static int
-ldbm_config_import_cache_autosize_set(void *arg,
-                                      void *value,
-                                      char *errorbuf __attribute__((unused)),
-                                      int phase __attribute__((unused)),
-                                      int apply)
+ldbm_config_db_debug_set(void *arg,
+                         void *value,
+                         char *errorbuf __attribute__((unused)),
+                         int phase __attribute__((unused)),
+                         int apply)
 {
     struct ldbminfo *li = (struct ldbminfo *)arg;
+    int retval = LDAP_SUCCESS;
+    int val = (int)((uintptr_t)value);
 
-    if (apply)
-        li->li_import_cache_autosize = (int)((uintptr_t)value);
-    return LDAP_SUCCESS;
+    if (apply) {
+        li->li_dblayer_private->dblayer_debug = val;
+    }
+
+    return retval;
 }
 
 static void *
-ldbm_config_cache_autosize_get(void *arg)
+ldbm_config_db_online_import_encrypt_get(void *arg)
 {
     struct ldbminfo *li = (struct ldbminfo *)arg;
 
-    return (void *)((uintptr_t)(li->li_cache_autosize));
+    return (void *)((uintptr_t)li->li_online_import_encrypt);
 }
 
 static int
-ldbm_config_cache_autosize_set(void *arg,
-                               void *value,
-                               char *errorbuf,
-                               int phase __attribute__((unused)),
-                               int apply)
+ldbm_config_db_online_import_encrypt_set(void *arg,
+                                         void *value,
+                                         char *errorbuf __attribute__((unused)),
+                                         int phase __attribute__((unused)),
+                                         int apply)
 {
     struct ldbminfo *li = (struct ldbminfo *)arg;
+    int retval = LDAP_SUCCESS;
+    int val = (int)((uintptr_t)value);
 
     if (apply) {
-        int val = (int)((uintptr_t)value);
-        if (val < 0 || val > 100) {
-            slapi_create_errormsg(errorbuf, SLAPI_DSE_RETURNTEXT_SIZE,
-                                  "Error: Invalid value for %s (%d). The value must be between \"0\" and \"100\"\n",
-                                  CONFIG_CACHE_AUTOSIZE, val);
-            slapi_log_err(SLAPI_LOG_ERR, "ldbm_config_cache_autosize_set",
-                          "Invalid value for %s (%d). The value must be between \"0\" and \"100\"\n",
-                          CONFIG_CACHE_AUTOSIZE, val);
-            return LDAP_UNWILLING_TO_PERFORM;
-        }
-        li->li_cache_autosize = val;
+        li->li_online_import_encrypt = val;
     }
-    return LDAP_SUCCESS;
+
+    return retval;
 }
 
 static void *
-ldbm_config_cache_autosize_split_get(void *arg)
+ldbm_config_idl_get_update(void *arg)
 {
     struct ldbminfo *li = (struct ldbminfo *)arg;
 
-    return (void *)((uintptr_t)(li->li_cache_autosize_split));
+    return (void *)((uintptr_t)li->li_idl_update);
 }
 
 static int
-ldbm_config_cache_autosize_split_set(void *arg,
-                                     void *value,
-                                     char *errorbuf,
-                                     int phase __attribute__((unused)),
-                                     int apply)
+ldbm_config_idl_set_update(void *arg,
+                           void *value,
+                           char *errorbuf __attribute__((unused)),
+                           int phase __attribute__((unused)),
+                           int apply)
 {
     struct ldbminfo *li = (struct ldbminfo *)arg;
+    int retval = LDAP_SUCCESS;
+    int val = (int)((uintptr_t)value);
 
     if (apply) {
-        int val = (int)((uintptr_t)value);
-        if (val < 0 || val > 100) {
-            slapi_create_errormsg(errorbuf, SLAPI_DSE_RETURNTEXT_SIZE,
-                                  "Error: Invalid value for %s (%d). The value must be between \"0\" and \"100\"\n",
-                                  CONFIG_CACHE_AUTOSIZE_SPLIT, val);
-            slapi_log_err(SLAPI_LOG_ERR, "ldbm_config_cache_autosize_split_set",
-                          "Invalid value for %s (%d). The value must be between \"0\" and \"100\"\n",
-                          CONFIG_CACHE_AUTOSIZE_SPLIT, val);
-            return LDAP_UNWILLING_TO_PERFORM;
-        }
-        li->li_cache_autosize_split = val;
+        li->li_idl_update = val;
     }
-    return LDAP_SUCCESS;
+
+    return retval;
 }
 
+
 static void *
 ldbm_config_import_cachesize_get(void *arg)
 {
